Attribute VB_Name = "SPELL"
Rem ******************************************************
Rem This module must be included in your application for
Rem Spell Time support.  This module contains constant
Rem definitions, function declarations, type declaration,
Rem and helper functions, such as DiscardNull.
Rem ******************************************************

Rem Constants used by Spell Time functions

Global Const ST_TRUE = 1
Global Const ST_FALSE = 0

Global Const STD_FOUND = 1
Global Const STD_NOT_FOUND = 0
Global Const STD_ERROR = -1

Global Const ST_MAX_WORD_LEN = 25
Global Const ST_DISPLAY_LEN = 15
Global Const ST_MAX_SUG_WORDS = 12

Global Const ST_GET_ALTERNATES = &H1

Global Const ST_INTERACTIVE = &H1
Global Const ST_BEEP = &H2

Global Const ST_IGNORE = &H1
Global Const ST_REPLACE = &H2
Global Const ST_REFRESH = &H4
Global Const ST_TOO_LONG = &H8
Global Const ST_ERROR = &H10
Global Const ST_EXIT = &H20
Global Const ST_ADD = &H40
Global Const ST_INPUT = &H80

Global Const STFLAG_USE_APOSTROPHE = &H1
Global Const STFLAG_SPANISH_DLG = &H2
Global Const STFLAG_APOSTROPHE_JOINER = &H4
Global Const STFLAG_NO_NUM_IN_WORD = &H8
Global Const STFLAG_DUTCH_DLG = &H10
Global Const STFLAG_GERMAN_DLG = &H20
Global Const STFLAG_FRENCH_DLG = &H40
Global Const STFLAG_ALL_CAPS_TO_LOWER = &H80


Rem Special variable type used by Spell Time

Type StResult
   code As Long               ' return codes
   replace As String * 41        ' replacement word
   reserved As String * 1        ' pad to 4 byte boundary - reqmt of VB 32 bit
   TotalAltWords As Long      ' number of alternate words
   AltWord1 As String * 41       ' list of alternate words
   AltWord2 As String * 41       ' list of alternate words
   AltWord3 As String * 41       ' list of alternate words
   AltWord4 As String * 41       ' list of alternate words
   AltWord5 As String * 41       ' list of alternate words
   AltWord6 As String * 41       ' list of alternate words
   AltWord7 As String * 41       ' list of alternate words
   AltWord8 As String * 41       ' list of alternate words
   AltWord9 As String * 41       ' list of alternate words
   AltWord10 As String * 41      ' list of alternate words
   AltWord11 As String * 41      ' list of alternate words
   AltWord12 As String * 41       ' list of alternate words
End Type

Rem ******************************************************
Rem Function declarations.
Rem ******************************************************

Declare Function SpellDict Lib "spell32.dll" (ByVal InputWord As String, ByVal WordLen As Long, ByVal flags As Long) As Long
Declare Function SpellWord Lib "spell32.dll" (ByVal InputWord As String, ByVal flag As Long, ByVal hWnd As Long, result As StResult) As Long
Declare Function StDelUserWord Lib "spell32.dll" (ByVal InputWord As String) As Long
Declare Function StResetUserDict Lib "spell32.dll" (NewDict As Any, OldDict As Any) As Long
Declare Function StParseLine Lib "spell32.dll" (ByVal buffer As String, ByVal Word As String, WordIndex As Long, CurIndex As Long, ByVal LineLen As Long) As Long
Declare Function StGetAlternateWord Lib "spell32.dll" (ByVal WordNo As Long, ByVal WordStr As String) As Long
Declare Function StClearHist Lib "spell32.dll" () As Long
Declare Function ToUserDict Lib "spell32.dll" (ByVal Word As String) As Long
Declare Function StLoadResult Lib "spell32.dll" (result As StResult) As Long
Declare Function ToSpellHist Lib "spell32.dll" (ByVal CurWord As String, ByVal flag As Long, ByVal RepWord As String) As Long
Declare Function StSetDictName Lib "spell32.dll" (ByVal DictName As String) As Long
Declare Function StSetFlags Lib "spell32.dll" (ByVal SetReset As Long, ByVal flag As Long) As Long
Declare Function SpellString Lib "spell32.dll" (ByVal InString As String, ByVal OutBuf As String, ByVal OutBufLen As Long, ByVal hWnd As Long) As Long

Declare Function SpellDict2 Lib "spell32.dll" (ByVal id As Long, ByVal InputWord As String, ByVal WordLen As Long, ByVal flags As Long) As Long
Declare Function SpellWord2 Lib "spell32.dll" (ByVal id As Long, ByVal InputWord As String, ByVal flag As Long, ByVal hWnd As Long, result As StResult) As Long
Declare Function StDelUserWord2 Lib "spell32.dll" (ByVal id As Long, ByVal InputWord As String) As Long
Declare Function StResetUserDict2 Lib "spell32.dll" (ByVal id As Long, NewDict As Any, OldDict As Any) As Long
Declare Function StParseLine2 Lib "spell32.dll" (ByVal id As Long, ByVal buffer As String, ByVal Word As String, WordIndex As Long, CurIndex As Long, ByVal LineLen As Long) As Long
Declare Function StGetAlternateWord2 Lib "spell32.dll" (ByVal id As Long, ByVal WordNo As Long, ByVal WordStr As String) As Long
Declare Function StClearHist2 Lib "spell32.dll" (ByVal id As Long) As Long
Declare Function ToUserDict2 Lib "spell32.dll" (ByVal id As Long, ByVal Word As String) As Long
Declare Function StLoadResult2 Lib "spell32.dll" (ByVal id As Long, result As StResult) As Long
Declare Function ToSpellHist2 Lib "spell32.dll" (ByVal id As Long, ByVal CurWord As String, ByVal flag As Long, ByVal RepWord As String) As Long
Declare Function StSetDictName2 Lib "spell32.dll" (ByVal id As Long, ByVal DictName As String) As Long
Declare Function StSetFlags2 Lib "spell32.dll" (ByVal id As Long, ByVal SetReset As Long, ByVal flag As Long) As Long
Declare Function StInitSession Lib "spell32.dll" () As Long
Declare Function StEndSession Lib "spell32.dll" (ByVal id As Long) As Long
Declare Function SpellString2 Lib "spell32.dll" (ByVal id As Long, ByVal InString As String, ByVal OutBuf As String, ByVal OutBufLen As Long, ByVal hWnd As Long) As Long
Declare Function StSetLicenseKey Lib "spell32.dll" (ByVal key As String) As Long

Declare Function StAddVowel Lib "spell32.dll" (ByVal chr As Long) As Long
Declare Function StAddVowel2 Lib "spell32.dll" (ByVal id As Long, ByVal chr As Long) As Long



'
Rem **************************************************
Rem When a string is passed for OUTPUT to the SPELL.DLL
Rem ,the output string created by the DLL has an extra
Rem NULL character.  For such strings, you must call
Rem this routine to strip the null character from the
Rem given string
Rem **************************************************
Function DiscardNull(InText As String) As String
   Dim i As Long
   Dim StrLen As Long
   Dim CurChar As String
   
   StrLen = Len(InText)

   For i = 1 To StrLen
      CurChar = left(InText, i)
      CurChar = right(CurChar, 1)

      If Asc(CurChar) = 0 Then
         DiscardNull = left(InText, i - 1)
         Exit Function
      End If
   Next i

   DiscardNull = InText
                       
End Function

